package example_account;

public class Account6Test {
	
	public static void main(String[] args) {
		testAccountCreation();
		testDeposit();
		testDeposit_NegativeAmount();
		testDeposit_Multiple();
		testWithdraw();
		testWithdraw_NegativeAmount();
		testWithdraw_Multiple();
		testDeposit_Withdraw();
		testNumberOfWithdrawals();
	}
	
	private static void testAccountCreation() {
		System.out.println("-->testAccountCreation()");
		Account6 a1 = new Account6(1000.0, "Dalton");
		String expected = "Expected: owner=Dalton, bal=1000.0, num withdrawals=0";
		String actual = "  Actual: " + a1.toString();
		System.out.println(expected);
		System.out.println(actual);
	}
	
	private static void testDeposit() {
		System.out.println("\n-->testDeposit()");
		Account6 a1 = new Account6(1000.0, "Leah");
		a1.deposit(500.0);
		System.out.println("balance should be $1500, balance=$" + a1.getBalance());
	}

	private static void testDeposit_NegativeAmount() {
		System.out.println("\n-->testDeposit_NegativeAmount()");
		Account6 a1 = new Account6(1000.0, "Leah");
		a1.deposit(-500.0);
		System.out.println("balance should be $1000, balance=$" + a1.getBalance());
	}

	private static void testDeposit_Multiple() {
		System.out.println("\n-->testDeposit_Multiple()");
		Account6 a1 = new Account6(1000.0, "Avery");
		a1.deposit(500.0);
		a1.deposit(300.0);
		System.out.println("balance should be $1800, balance=$" + a1.getBalance());
	}

	private static void testWithdraw() {
		System.out.println("\n-->testWithdraw()");
		Account6 a1 = new Account6(1000.0, "Leah");
		a1.withdraw(500.0);
		System.out.println("balance should be $500, balance=$" + a1.getBalance());
		System.out.println("num withdrawals should be 1, numWithdrawals=" + a1.getNumWithdrawals());
	}

	private static void testWithdraw_NegativeAmount() {
		System.out.println("\n-->testDeposit_NegativeAmount()");
		Account6 a1 = new Account6(1000.0, "Leah");
		a1.withdraw(-500.0);
		System.out.println("balance should be $1000, balance=$" + a1.getBalance());
		System.out.println("num withdrawals should be 0, numWithdrawals=" + a1.getNumWithdrawals());
	}

	private static void testWithdraw_Multiple() {
		System.out.println("\n-->testWithdraw_Multiple()");
		Account6 a1 = new Account6(1000.0, "Avery");
		a1.withdraw(200.0);
		a1.withdraw(300.0);
		System.out.println("balance should be $500, balance=$" + a1.getBalance());
		System.out.println("num withdrawals should be 2, numWithdrawals=" + a1.getNumWithdrawals());
	}

	private static void testDeposit_Withdraw() {
		System.out.println("\n-->testDeposit_Withdraw()");
		Account6 a1 = new Account6(1000.0, "Zoe");
		a1.withdraw(500.0);
		a1.deposit(300.0);
		a1.deposit(400.0);
		a1.withdraw(250.0);
		a1.withdraw(250.0);
		System.out.println("balance should be $700, balance=$" + a1.getBalance());
		System.out.println("num withdrawals should be 3, numWithdrawals=" + a1.getNumWithdrawals());
	}
	
	public static void testNumberOfWithdrawals() {
		System.out.println("\n-->testNumberOfWithdrawals()");
		Account6 a1 = new Account6(2500.0, "Mark");
		int numWithdrawals = 5;
		int totalWithdrawn = 0;
		for(int i = 0; i < numWithdrawals; i++) {
			int rand = (int) Math.floor(Math.random() * 250);
			totalWithdrawn += rand;
			a1.withdraw(rand);
		}
		System.out.println("balance should be " + (2500.0 - totalWithdrawn) + ", balance=$" + a1.getBalance());
		System.out.println("num withdrawals should be " + numWithdrawals + ", numWithdrawals=" + a1.getNumWithdrawals());
	}
}
