package example_account_0;

public class Account {
	
	private double balance;
	private String owner;

	public String getOwner() {
		return owner;
	}

	public void setOwner(String newOwner) {
		owner = newOwner;
	}

	// No-arg constructor
	public Account() {
		balance = 0.0;
	}
	
	public Account(double initBalance) {
		balance = initBalance;
	}
	
	public Account(double initBalance, String initName) {
		balance = initBalance;
		owner = initName;
	}

	public double getBalance() {
		return balance;
	}
	
	public void setBalance(double newBal) {
		if(newBal>0.0) {
			balance = newBal;
		}
	}
	
	public void deposit(double amount) {
		if(amount>0) {
			balance += amount;
		}
	}

	public void withdraw(double amount) {
		if(amount>0) {
			balance -= amount;
		}
	}

	@Override
	public String toString() {
		String msg = String.format("Account: balance=$%,.2f", balance);
		return msg;
	}
	
	public static void main(String[] args) {
		Account account = new Account(1000.0);
		account.deposit(200.0);
		account.withdraw(400.0);
		System.out.println("bal=" + account.balance);
				
		
		Account a1 = new Account(836.43);
		a1.deposit(163.57);
		System.out.println("Balance=$" + a1.getBalance());
		Account a2 = new Account(200.0);
		a2.deposit(50.0);
		System.out.println("Balance=$" + a2.getBalance());
		
		Account a3 = new Account(500.0, "Xavier");
		System.out.println("Name=" + a3.getOwner());  // Xavier
		a3.setOwner("Marco");
		System.out.println("Name=" + a3.getOwner());  // Marco
		
	
	}
	
	
}

