package example_basketball_array_instance_variable;

public class BasketballTeam {

	private String name;
	private int[] points = new int[4];
	
	public BasketballTeam(String name, int pointsQ1, int pointsQ2, int pointsQ3, int pointsQ4) {
		this.name = name;
		points[0] = pointsQ1;
		points[1] = pointsQ2;
		points[2] = pointsQ3;
		points[3] = pointsQ4;
		
	}

	public String getName() {
		return name;
	}
	
	public int getPoints(int quarter) {
		if( (quarter < 0) || (quarter>=points.length) ) {
			return -1;
		}
		return points[quarter];
	}
	
	public void setPoints(int quarter, int numPoints) {
		if( (quarter < 0) || (quarter>=points.length) ) {
			return;
		}
		points[quarter] = numPoints;
	}
	
	public int totalPoints() {
		int sum = 0;
		for(int i=0; i<points.length; i++) {
			sum += points[i];
		}
		return sum;
	}
	
	public int numQuartersMoreThan(int numPoints) {
		int sum = 0;
		for(int i=0; i<points.length; i++) {
			if(points[i] > numPoints) {
				sum++;
			}
		}
		return sum;
		
	}

	@Override
	public String toString() {
		String msg = String.format("Team Name: %s, Total Points: %d\n", name, totalPoints());
		msg += String.format("  Q1:%d, Q2:%d, Q3:%d, Q4:%d", points[0], points[1], points[2], points[3]);
		return msg;
	}
	
	public static void main(String[] args) {
		String msg;
		
		BasketballTeam team = new BasketballTeam("Hawks", 18, 23, 31, 26);
		System.out.println(team);
		
		int q3Points = team.getPoints(2);
		msg = String.format("\n3rd Quarter Points: %d", q3Points);
		System.out.println(msg);
		
		int totPoints = team.totalPoints();
		msg = String.format("\nTotal Points: %d", totPoints);
		System.out.println(msg);
		
		team.setPoints(3,33); // Change 4th quarter points
		System.out.println("\n" + team);
		
		int numQMore20 = team.numQuartersMoreThan(20);
		msg = String.format("\nNum Quarters More than 20 point: %d", numQMore20);
		System.out.println(msg);

	}

}

