package example_box_utilities;

public class Box {

	public static void main(String[] args) {
		
		Box b1 = new Box(7.0,8.0,4.0);
		Box b2 = new Box(2.0,3.0,4.0);
		Box b3 = new Box(1.0,5.0,3.0);

		boolean doesFit1 = b1.doesFit(b2);
		boolean doesFit2 = b1.doesFit(b3);
		
		System.out.println("b1=" + b1);
		System.out.println("b2=" + b2);
		System.out.println("b3=" + b3);
		
	    System.out.println("b2 fit in b1? " + doesFit1);
	    System.out.println("b3 fit in b1? " + doesFit2);
	}
	
	private double length, width, height;
		   
	public Box() {
		this(1,1,1);
	}
		   
	public Box(double l, double w, double h) {
		length = l; 
		width = w;
		height = h;
	}

	public double getLength() {
		return length;
	}

	public double getWidth() {
		return width;
	}

	public double getHeight() {
		return height;
	}

	public double getVolume() {
		return length*width*height;
	}
	
	public void stretchLenth(double percent) {
		length = length*(1+percent);
	}
	
	/*
	 * Determines if b will fit inside this Box, if all dimensions of b are less than those for this Box.
	 */
	public boolean doesFit(Box b) {
		if((b.length<this.length) &&
				(b.width<this.width) &&
				(b.height<this.height)) {
			return true;
		}
		else {
			return false;
		}
	}
	@Override
	public String toString() {
		String msg = String.format("len=%.1f, wid=%.1f, ht=%.1f, vol=%.1f", length, width, height, getVolume());
		return msg;
	}
}
