package example_box_utilities;

public class BoxUtilitiesTest {

	public static void main(String[] args) {
		testGetAverageVolume();
		testStretchAll();
		testGetBiggest();
		testWhichOnesFit();
	}
	
	private static void testGetAverageVolume() {
		System.out.println("Test getAverageVolume(boxes)");
		Box[] boxes1 = createBoxes1();
		BoxUtilities bu = new BoxUtilities();
	      
		double avgVol = bu.getAverageVolume(boxes1);

		String msg = String.format("Avg vol=%.2f", avgVol);
		System.out.println(msg);
	}

	private static void testStretchAll() {
		System.out.println("\nTest stretchAll(boxes,0.1)");
		Box[] boxes1 = createBoxes1();
		BoxUtilities bu = new BoxUtilities();
	      
		System.out.println("before stretch");
		for(Box b : boxes1) System.out.println(b);
		
		bu.stretchAll(boxes1, 0.1);
		
		System.out.println("after stretch");
		for(Box b : boxes1) System.out.println(b);
	}

	private static void testGetBiggest() {
		System.out.println("\nTest getBiggest(boxes1,boxes2)");
		Box[] boxes1 = createBoxes1();
		Box[] boxes2 = createBoxes2();
		BoxUtilities bu = new BoxUtilities();

		System.out.println("boxes1=");
		for(Box b : boxes1) System.out.println(b);
		System.out.println("boxes2=");
		for(Box b : boxes2) System.out.println(b);
	      
		Box[] biggest = bu.getBiggest(boxes1, boxes2);
		
		System.out.println("biggest=");
		for(Box b : biggest) System.out.println(b);
	}

	private static void testWhichOnesFit() {
		System.out.println("\nTest whichOnesFit(boxes1,boxes2)");
		Box[] boxes1 = createBoxes1();
		Box[] boxes2 = createBoxes2();
		BoxUtilities bu = new BoxUtilities();

		System.out.println("boxes1=");
		for(Box b : boxes1) System.out.println(b);
		System.out.println("boxes2=");
		for(Box b : boxes2) System.out.println(b);
	      
		boolean[] whichFit = bu.whichOnesFit(boxes1, boxes2);
		
		System.out.println("whichFit=");
		for(boolean b : whichFit) System.out.println(b);
	}

	private static Box[] createBoxes1() {
		Box[] boxes1 = new Box[3];
		boxes1[0] = new Box(4,4,4);
		boxes1[1] = new Box(9,9,9);
		boxes1[2] = new Box(6,6,6);
		return boxes1;
	}
	
	private static Box[] createBoxes2() {
	    Box[] boxes2 = new Box[3];
	    boxes2[0] = new Box(5,5,5);
	    boxes2[1] = new Box(10,8,8);
	    boxes2[2] = new Box(3,3,3);
	    return boxes2;
	}
}
