package example_box_utilities;

public class SavingsAccount {
	private String owner;
	private double balance;

	public SavingsAccount(double balance) {
		this("unknown", balance);
	}
	
	public SavingsAccount(String name) {
		this(name, 0.0);
	}
	
	public SavingsAccount(String name, double balance) {
		this.owner = name;
		this.balance = balance;
	}
	
	public double getBalance() {
		return balance;
	}

	public String getOwner() {
		return owner;
	}

	public void deposit(double amount) {
		if(amount>0)
			balance += amount;
	}

	public void withdraw(double amount) {
		if(amount>0)
			balance -= amount;
	}

	public void applyInterest(double intRate) {
		if(intRate>0)
			balance *= (1+intRate);
	}

	public void applyInterest() {
		applyInterest(0.1);
	}
	
	public void mergeAccount(SavingsAccount sa) {
		if(this.owner.equals(sa.owner)) {
			this.balance += sa.balance;
		}
	}

	@Override
	public String toString() {
		String msg = String.format("Owner=%s, bal=$%,.2f", owner, balance);
		return msg;
	}
	public static void main(String[] args) {
		SavingsAccount sa = new SavingsAccount("Angeline", 2000.0);
		System.out.println(sa);
		sa.deposit(500.0);
		System.out.println(sa);
		sa.withdraw(200.0);
		System.out.println(sa);
		sa.applyInterest(0.2);
		System.out.println(sa);
		sa.applyInterest();
		System.out.println(sa);
		SavingsAccount sa2= new SavingsAccount("Walter", 500.0);
		sa.mergeAccount(sa2);
		System.out.println(sa);
		SavingsAccount sa3= new SavingsAccount("Angeline", 1000.0);
		sa.mergeAccount(sa3);
		System.out.println(sa);
	}


}
