package example_box_utilities;

public class SavingsAccount2 {
	private String owner;
	private double balance;

	public SavingsAccount2(String name, double balance) {
		this.owner = name;
		this.balance = balance;
	}

	public double getBalance() {
		return balance;
	}

	public String getOwner() {
		return owner;
	}

	public void deposit(double amount) {
		if(amount>0)
			balance += amount;
	}

	public void withdraw(double amount) {
		if(amount>0)
			balance -= amount;
	}

	public void applyInterest(double intRate) {
		if(intRate>0)
			balance *= (1+intRate);
	}

	public void mergeAccount(SavingsAccount2 sa) {
		if(this.owner.equals(sa.getOwner())) {
			deposit(sa.getBalance());
		}
	}


	@Override
	public String toString() {
		return "SavingsAccount: name=" + owner + ", balance=" + balance;
	}
	public static void main(String[] args) {
		SavingsAccount2 sa = new SavingsAccount2("Angeline", 2000.0);
		System.out.println(sa);
		SavingsAccount2 sa2 = new SavingsAccount2("Angeline", 1000.0);
		System.out.println(sa2);
		sa.mergeAccount(sa2);
		System.out.println(sa);
	}


}
