package example_box_utilities;

public class SavingsAccount4 {
	double balance;
	private String accountOwner;

	public SavingsAccount4() {
		this(0.0,"unknown");
	}

	public SavingsAccount4(double balance) {
		this(balance, "unknown");
	}

	public SavingsAccount4(String accountOwner) {
		this(0.0, accountOwner);
	}

	public SavingsAccount4(double balance, String accountOwner) {
		this.balance = balance;
		this.accountOwner = accountOwner;
	}
	
	public double getBalance() {
		return balance;
	}
	
	public void deposit(double amount) {
		balance += amount;
	}
	
	public void withdraw(double amount) {
		balance -= amount;
	}
	
	public void applyInterest(double intRate) {
		balance *= (1+intRate);
	}

	public String getAccountOwner() {
		return accountOwner;
	}

	public void setAccountOwner(String accountOwner) {
		this.accountOwner = accountOwner;
	}
	
	public void mergeAccount(SavingsAccount4 sa) {
		if(this.accountOwner.equals(sa.getAccountOwner())) {
			deposit(sa.getBalance());
		}
	}
	
	public static void main(String[] args) {
		
		SavingsAccount4[] acnts = {
				new SavingsAccount4(),
				new SavingsAccount4(5000.0),
				new SavingsAccount4("Tenesha"),
				new SavingsAccount4(20000.0, "Tenesha")
		};

		for(SavingsAccount4 sa : acnts) {
			System.out.println(String.format("Account owner=%s, balance=$%,.2f", sa.getAccountOwner(), sa.getBalance()));		
		}
	}

}
