package example_box_utilities;

public class SavingsAccountUtilities {

	public static void main(String[] args) {
	}
	
	public SavingsAccountUtilities() {}
	
	public double getTotalBalance(SavingsAccount[] accounts) {
		double sum = 0.0;
		for(SavingsAccount a : accounts) {
			sum += a.getBalance();
		}
		return sum;
	}
	
	public void applyInterest(SavingsAccount[] accounts, double rate) {
		for(SavingsAccount a : accounts) {
			a.applyInterest(rate);
		}
	}

	public String getAccountsReport(SavingsAccount[] accounts) {
		String report = "Accounts Summary\n";
			   report += "----------------\n";
		report += "Num accounts = " + accounts.length + "\n";
		String msg = String.format("Total balance = $%,.2f", getTotalBalance(accounts));
		report += msg + "\n";
		report += "\nAccounts:\n";
		for(SavingsAccount a : accounts) {
			report += a.toString() + "\n";
		}
		return report;
	}

	public String[] getAccountOwnersList(SavingsAccount[] accounts) {
		String[] names = new String[accounts.length];
		int i=0;
		for(SavingsAccount a : accounts) {
			names[i++] = a.getOwner();
		}
		return names;
	}

	public SavingsAccount[] getSmallestAccounts(SavingsAccount[] accounts1, SavingsAccount[] accounts2) {
		SavingsAccount[] smallest = new SavingsAccount[accounts1.length];
		for(int i=0; i<accounts1.length; i++) {
			SavingsAccount a1 = accounts1[i];
			SavingsAccount a2 = accounts2[i];
			if(a1.getBalance()<a2.getBalance())
				smallest[i] = a1;
			else
				smallest[i] = a2;
		}
		return smallest;
	}
}
