package example_foreach;

public class Account {

	private double balance;

	// No-arg constructor
	public Account() {
		balance = 0.0;
	}
	
	public Account(double balance) {
		this.balance = balance;
	}
	
	public double getBalance() {
		return balance;
	}
	
	public void setBalance(double newBal) {
		if(newBal>0.0) {
			balance = newBal;
		}
	}
	
	public void deposit(double amount) {
		if(amount>0) {
			balance += amount;
		}
	}

	public void withdraw(double amount) {
		if(amount>0) {
			balance -= amount;
		}
	}

	@Override
	public String toString() {
		String msg = String.format("Account: balance=$%,.2f", balance);
		return msg;
	}

	public static void main(String[] args) {
		Account a1 = new Account(836.43);
		a1.deposit(163.57);
		System.out.println("Balance=$" + a1.getBalance());
		Account a2 = new Account(200.0);
		a2.deposit(50.0);
		System.out.println("Balance=$" + a2.getBalance());
	}
	
	
}

