package example_foreach;

public class AccountTest {

	public static void main(String[] args) {
		standardForLoop();
		enhancedForLoop();
		exampleLocationOfMinimum();
		everyOther();
		backwards();
		twoArrays();
	}
	
	private static void standardForLoop() {
		System.out.println("-->standardForLoop()");
		int[] vals = {7,3,5,2};
		for(int i=0; i<vals.length; i++) {
			int x = vals[i];
			System.out.println(x + " ");
		}
	}
	
	private static void enhancedForLoop() {
		System.out.println("-->enhancedForLoop()");
		int[] vals = {7,3,5,2};
		for(int x : vals) {
			System.out.println(x + " ");
		}
	}

	private static void combined() {
		System.out.println("-->combined()");
		
		int[] vals = {7,3,5,2};
		
		// index loop
		for(int i=0; i<vals.length; i++) {
			int x = vals[i];
			System.out.println(x + " ");
		}
		
		// for-each loop
		for(int x : vals) {
			System.out.println(x + " ");
		}
	}
	
	private static void exampleLocationOfMinimum() {
		System.out.println("-->exampleLocationOfMinimum()");
		int[] vals = {7,3,5,2,8};
		int locMin = locationOfMinimum(vals);
		System.out.println("loc min=" + locMin);
	}
	
	private static int locationOfMinimum(int[] vals) {
		System.out.println("-->locationOfMinimum()");
		int min = Integer.MAX_VALUE;
		int locMin = -1;
		for(int i=0; i<vals.length; i++) {
			if(vals[i]<min) {
				min = vals[i];
				locMin = i;
			}
		}
		return locMin;
	}

	private static void everyOther() {
		System.out.println("-->everyOther()");
		int[] vals = {7,3,5,2};
		for(int i=0; i<vals.length; i+=2) {
			System.out.println(vals[i] + " ");
		}
	}

	private static void backwards() {
		System.out.println("-->backwards()");
		int[] vals = {7,3,5,2};
		for(int i=vals.length-1; i>=0; i--) {
			System.out.println(vals[i] + " ");
		}
	}

	private static void twoArrays() {
		System.out.println("-->twoArrays()");
		int[] xVals = {7,3,5,2};
		int[] yVals = {1,4,2,6};
		for(int i=0; i<xVals.length; i++) {
			int x = xVals[i];
			int y = yVals[i];
			System.out.println(x + " " + y + " ");
		}
	}

}
