package example_string_format;

public class StringFormatExamples {
	public static void main(String[] args) {
		String[] names = {"Jed", "Keisha", "Jaylen"};
		int[] ages = {22, 33, 44};
		double[] salaries = {48339.23423, 68992.92430, 121042.04328};
		String report = buildReport(names, ages, salaries);
		System.out.println(report);

		double[] weights = {48339.23423, 68992.92430, 121042.04328};
		report = formatWeights(weights, 3);
		System.out.println(report);
		
		// Example in notes:
		
		String name = "Waldo";
		int age=23;
		double weight = 145.8230842;
		String result = String.format("name=%s, age=%d, weight=%,.2f", name, age, weight);
		System.out.println(result);

		double salary = 78224.8230842;
		result = String.format("Salary=$%,.2f", salary);
		System.out.println(result);
		
		double x = 498.57334;
		result = String.format("x=%8.2f", x);
		System.out.println(result);
		
		double y = 6.1945;
		System.out.printf("x=%8.2f\ny=%8.2f", x, y);

	}

	public static String buildReport(String[] names, int[] ages, double[] salaries) {
		String report = "";
		for(int i=0; i<names.length; i++) {
			String line = String.format("Name: %s, age:%d, salary: $%,.2f\n", names[i], ages[i], salaries[i]);
			report += line;
		}
		return report;
	}
	
	public static String formatWeights(double[] weights, int n) {
		String formatString = "%." + n + "f ";
		String report = "";
		for(int i=0; i<weights.length; i++) {
			report += String.format(formatString, weights[i]);
		}
		return report;
	}
	
}
