package example_word_class;

public class WordTest {

	public static void main(String[] args) {
		testCountUC();
		testCountVowels();
		testCountVowels2();
		testAddToWord_NoComma();
		testAddToWord_WithComma();
		testGetUniqueCharacters();
		testContainsDotCom();
	}
	
	private static void testCountUC() {
		System.out.println("-->testCountUC()");
		Word w1 = new Word("orange");
		int num = w1.countUC();
		System.out.println(w1);
		System.out.println("Should be 0 upper case: " + num);
		
		Word w2 = new Word("Orange");
		num = w2.countUC();
		System.out.println(w2);
		System.out.println("Should be 1 upper case: " + num);

		Word w3 = new Word("OraNgE");
		num = w3.countUC();
		System.out.println(w3);
		System.out.println("Should be 3 upper case: " + num);
	}

	private static void testCountVowels() {
		System.out.println("\n-->testCountVowels()");
		Word w1 = new Word("zbrxy");
		int num = w1.countVowels();
		System.out.println(w1);
		System.out.println("Should be 0 vowels: " + num);
		
		Word w2 = new Word("zrang");
		num = w2.countVowels();
		System.out.println(w2);
		System.out.println("Should be 1 vowels: " + num);

		Word w3 = new Word("orange");
		num = w3.countVowels();
		System.out.println(w3);
		System.out.println("Should be 3 vowels: " + num);
	}

	private static void testCountVowels2() {
		System.out.println("\n-->testCountVowels2()");
		Word w1 = new Word("zbrxy");
		int num = w1.countVowels2();
		System.out.println(w1);
		System.out.println("Should be 0 vowels: " + num);
		
		Word w2 = new Word("zrang");
		num = w2.countVowels2();
		System.out.println(w2);
		System.out.println("Should be 1 vowels: " + num);

		Word w3 = new Word("orange");
		num = w3.countVowels2();
		System.out.println(w3);
		System.out.println("Should be 3 vowels: " + num);
	}

	private static void testAddToWord_NoComma() {
		System.out.println("\n-->testAddToWord_NoComma()");
		
		Word w1 = new Word("Orange");
		w1.addToWord("Peel");  // "OrangePeel"
		System.out.println("Word should be 'OrangePeel':" + w1.getWord());
	}

	private static void testAddToWord_WithComma() {
		System.out.println("\n-->testAddToWord_WithComma()");
		
		Word w1 = new Word("Orange");
		w1.addToWord("Peel,Now");  // "OrangePeel"
		System.out.println("Word should be 'OrangePeelNow':" + w1.getWord());
	}

	private static void testGetUniqueCharacters() {
		System.out.println("\n-->testGetUniqueCharacters()");
		Word w1 = new Word("Orange");
		String chars = w1.getUniqueCharacters();
		System.out.println("Unique chars should be 'Orange':" + chars);

		Word w2 = new Word("Orrn");
		chars = w2.getUniqueCharacters();
		System.out.println("Unique chars should be 'Orn':" + chars);

		Word w3 = new Word("zabtabzv");
		chars = w3.getUniqueCharacters();
		System.out.println("Unique chars should be 'zabtv':" + chars);
	}

	private static void testContainsDotCom() {
		System.out.println("\n-->testContainsDotCom()");
		Word w1 = new Word("Orange");
		boolean b1 = w1.containsDotCom();
		System.out.println(w1);
		System.out.println("w1.containsDotCom()=" + b1);

		Word w2 = new Word("email@.com");
		boolean b2 = w2.containsDotCom();
		System.out.println(w2);
		System.out.println("w2.containsDotCom()=" + b2);

		Word w3 = new Word("email@.comisnotready");
		boolean b3 = w3.containsDotCom();
		System.out.println(w3);
		System.out.println("w3.containsDotCom()=" + b3);
	
	}

}
