package exercise_box;

public class Box {

	private double length;
	private double width;
	private double height;
	   
	public Box(double length, double width, double height) {
		this.length = length;
		this.width = width;
		this.height = height;
	}

	public Box(double val) {
		this(val, val, val);
	}

	public Box() {
		this(1.0, 1.0, 1.0);
	}

	public double volume() {
		return length*width*height;
	}
	
	@Override
	public String toString() {
		return "Box [length=" + length + ", width=" + width + ", height="
					+ height + ", volume()=" + volume() + "]";
	}

	public static void main(String[] args) {
		
		Box b1 = new Box(2.0, 3.0, 4.0);
		Box b2 = b1;
		Box b3 = new Box(1.0,5.0,3.0);
		System.out.println("Expected: b1 == b2? true");
		System.out.println("  Actual: b1 == b2? " + (b1==b2));
		System.out.println("Expected: b2 == b3? false");
		System.out.println("  Actual: b2 == b3? " + (b2==b3));
		
		System.out.println("\n-->testBox_NoArgs()");
		Box b4 = new Box();
		System.out.println("Expected: Box [length=1.0, width=1.0, height=1.0, volume()=1.0]");
		System.out.println("  Actual: " + b4);
		
		System.out.println("\n-->testBox_OneArg()");
		Box b5 = new Box(2.5);
		System.out.println("Expected: Box [length=2.5, width=2.5, height=2.5, volume()=15.625]");
		System.out.println("  Actual: " + b5);
		
		System.out.println("\n-->testBox_ThreeArgs()");
		Box b6 = new Box(3.0, 5.0, 4.0);
		System.out.println("Expected: Box [length=3.0, width=5.0, height=4.0, volume()=60.0]");
		System.out.println("  Actual: " + b6);
	}
}
