package exercise_cellular_account;

public class CellularAccountVer2 {
	public double minutesMax;
	public double costPerMin;
	public double minutesUsed;  

	public CellularAccountVer2(double maxMinutes, double costPerMinute) {
		minutesMax = maxMinutes;
		costPerMin = costPerMinute;
		minutesUsed = 0.0;
	}

	public double getAmountDue() {
		double cellCost = 0.0;
		if(minutesUsed > minutesMax) {
			double extraMin = minutesUsed - minutesMax;
			cellCost = costPerMin*minutesMax + (1+0.4)*costPerMin*extraMin;
		}
		else {
			cellCost = costPerMin*minutesUsed;
		}
		return cellCost;
	}

	public static void main(String[] args) {
		CellularAccountVer2 acct1 = new CellularAccountVer2(500.0, 0.05);
		acct1.minutesUsed = 300.0;
		System.out.println("Expected = Amount Due=$15.00, Used=300.0 min., Max=500.0 min., Cost Per Min=0.05");
		System.out.println(String.format("  Actual = Amount Due=$%.2f, Used=%.1f min., Max=%.1f min., Cost Per Min=%.2f", 
										acct1.getAmountDue(), acct1.minutesUsed, acct1.minutesMax, acct1.costPerMin));
		
		CellularAccountVer2 acct2 = new CellularAccountVer2(500.0, 0.05);
		acct2.minutesUsed = 600.0;
		System.out.println("Expected = Amount Due=$32.00, Used=600.0 min., Max=500.0 min., Cost Per Min=0.05");
		System.out.println(String.format("  Actual = Amount Due=$%.2f, Used=%.1f min., Max=%.1f min., Cost Per Min=%.2f", 
										acct2.getAmountDue(), acct2.minutesUsed, acct2.minutesMax, acct2.costPerMin));
	}
}
