package exercise_cellular_account;

public class CellularAccountVer4 {
	private double minutesMax;
	private double costPerMin;
	private double minutesUsed;

	public CellularAccountVer4(double minutesMax, double costPerMin) {
		this.minutesMax = minutesMax;
		this.costPerMin = costPerMin;
		this.minutesUsed = 0.0;
	}
	
	public double getMinutesMax() {
		return minutesMax;
	}

	public void setMinutesMax(double minutesMax) {
		this.minutesMax = minutesMax;
	}

	public double getCostPerMin() {
		return costPerMin;
	}

	public void setCostPerMin(double costPerMin) {
		this.costPerMin = costPerMin;
	}

	public double getMinutesUsed() {
		return minutesUsed;
	}
	
	public void makeCall(double length) {
		minutesUsed += length;
	}
	
	public double getAmountDue() {
		double cellCost = 0.0;
		if(minutesUsed > minutesMax) {
			double extraMin = minutesUsed - minutesMax;
			cellCost = costPerMin*minutesMax + (1+0.4)*costPerMin*extraMin;
		}
		else {
			cellCost = costPerMin*minutesUsed;
		}
		return cellCost;
	}
	

	public static void main(String[] args) {
		CellularAccountVer4 acct1 = new CellularAccountVer4(500.0, 0.05);
		acct1.makeCall(300);
		System.out.println("Expected = Amount Due=$15.00, Used=300.0 min., Max=500.0 min., Cost Per Min=0.05");
		System.out.println(String.format("  Actual = Amount Due=$%.2f, Used=%.1f min., Max=%.1f min., Cost Per Min=%.2f", 
				acct1.getAmountDue(), acct1.getMinutesUsed(), acct1.getMinutesMax(), acct1.getCostPerMin()));
		
		acct1.setMinutesMax(1000.0);
		acct1.makeCall(500);
		System.out.println("Expected = Amount Due=$40.00, Used=500.0 min., Max=1000.0 min., Cost Per Min=0.05");
		System.out.println(String.format("  Actual = Amount Due=$%.2f, Used=%.1f min., Max=%.1f min., Cost Per Min=%.2f", 
							acct1.getAmountDue(), acct1.getMinutesUsed(), acct1.getMinutesMax(), acct1.getCostPerMin()));
		
		acct1.setCostPerMin(0.10);
		acct1.makeCall(250.0);
		System.out.println("Expected = Amount Due=$107.00, Used=1500.0 min., Max=1000.0 min., Cost Per Min=0.10");
		System.out.println(String.format("  Actual = Amount Due=$%.2f, Used=%.1f min., Max=%.1f min., Cost Per Min=%.2f", 
				acct1.getAmountDue(), acct1.getMinutesUsed(), acct1.getMinutesMax(), acct1.getCostPerMin()));
	}
}
