package exercise_cellular_account;

public class CellularAccountVer7 {
	private double minutesMax;
	private double costPerMin;
	private double minutesUsed;
	private boolean isNearMax;

	public CellularAccountVer7(double minutesMax, double costPerMin) {
		this.minutesMax = minutesMax;
		this.costPerMin = costPerMin;
		this.minutesUsed = 0.0;
		evalIsNearMax();
	}
	
	public double getMinutesMax() {
		return minutesMax;
	}

	public void setMinutesMax(double minutesMax) {
		this.minutesMax = minutesMax;
	}

	public double getCostPerMin() {
		return costPerMin;
	}

	public void setCostPerMin(double costPerMin) {
		this.costPerMin = costPerMin;
	}

	public double getMinutesUsed() {
		return minutesUsed;
	}
	
	public boolean isNearMax() {
		return isNearMax;
	}

	public void makeCall(double length) {
		if(length > 0.00) {
			minutesUsed += length;
		}
		evalIsNearMax();
	}
	
	public double getAmountDue() {
		double cellCost = 0.0;
		if(minutesUsed > minutesMax) {
			double extraMin = minutesUsed - minutesMax;
			cellCost = costPerMin*minutesMax + (1+0.4)*costPerMin*extraMin;
		}
		else {
			cellCost = costPerMin*minutesUsed;
		}
		return cellCost;
	}
	
	@Override
	public String toString() {
		String msg = "Amount Due=$" + getAmountDue() + ", Used=" + minutesUsed + "., Max=" + 
				 minutesMax + "., Cost Per Min=" + costPerMin;
		return msg;
	}
	
	private void evalIsNearMax() {
		this.isNearMax = Math.abs(minutesMax - minutesUsed) <= 50 ? true : false;
	}
}
