package exercise_piggy_bank;

public class PiggyBankVer6Test {

	public static void main(String[] args) {
		testAddQuarters_PositiveQty();
		testAddQuarters_NegativeQty();
		testWithdrawQuarters_PositiveQty();
		testWithdrawQuarters_NegativeQty();
		testAddDimes_PositiveQty();
		testAddDimes_NegativeQty();
		testAddNickles_PositiveQty();
		testAddNickles_NegativeQty();
		testGetTotal();
		testToString();	
	}

	private static void testAddQuarters_PositiveQty() {
		System.out.println("-->testAddQuarters_PositiveQty()");
		PiggyBankVer6 pBank = new PiggyBankVer6(3, 2, 3);
		System.out.println("Expected: Number of Quarters before adding = 3");
		System.out.println(String.format("  Actual: Number of Quarters before adding = %d", pBank.getQuarters()));
		pBank.addQuarters(2);
		System.out.println("Expected: Number of Quarters after adding = 5");
		System.out.println(String.format("  Actual: Number of Quarters after adding = %d", pBank.getQuarters()));
	}
	
	private static void testAddQuarters_NegativeQty() {
		System.out.println("\n-->testAddQuarters_NegativeQty()");
		PiggyBankVer6 pBank = new PiggyBankVer6(3, 2, 3);
		System.out.println("Expected: Number of Quarters before adding = 3");
		System.out.println(String.format("  Actual: Number of Quarters before adding = %d", pBank.getQuarters()));
		pBank.addQuarters(-5);
		System.out.println("Expected: Number of Quarters after adding = 3");
		System.out.println(String.format("  Actual: Number of Quarters after adding = %d", pBank.getQuarters()));
	}
	
	private static void testWithdrawQuarters_PositiveQty() {
		System.out.println("\n-->testWithdrawQuarters_PositiveQty()");
		PiggyBankVer6 pBank = new PiggyBankVer6(3, 2, 3);
		System.out.println("Expected: Number of Quarters before withdrawing = 3");
		System.out.println(String.format("  Actual: Number of Quarters before withdrawing = %d", pBank.getQuarters()));
		pBank.withdrawQuarters(2);
		System.out.println("Expected: Number of Quarters after withdrawing = 1");
		System.out.println(String.format("  Actual: Number of Quarters after withdrawing = %d", pBank.getQuarters()));
	}
	
	private static void testWithdrawQuarters_NegativeQty() {
		System.out.println("\n-->testWithdrawQuarters_NegativeQty()");
		PiggyBankVer6 pBank = new PiggyBankVer6(3, 2, 3);
		System.out.println("Expected: Number of Quarters before withdrawing = 3");
		System.out.println(String.format("  Actual: Number of Quarters before withdrawing = %d", pBank.getQuarters()));
		pBank.withdrawQuarters(-2);
		System.out.println("Expected: Number of Quarters after withdrawing = 3");
		System.out.println(String.format("  Actual: Number of Quarters after withdrawing = %d", pBank.getQuarters()));
	}
	
	private static void testAddDimes_PositiveQty() {
		System.out.println("\n-->testAddDimes_PositiveQty()");
		PiggyBankVer6 pBank = new PiggyBankVer6(3, 2, 3);
		System.out.println("Expected: Number of Dimes before adding = 2");
		System.out.println(String.format("  Actual: Number of Dimes before adding = %d", pBank.getDimes()));
		pBank.addDimes(2);
		System.out.println("Expected: Number of Dimes after adding = 4");
		System.out.println(String.format("  Actual: Number of Dimes after adding = %d", pBank.getDimes()));
		
	}
	
	private static void testAddDimes_NegativeQty() {
		System.out.println("\n-->testAddDimes_NegativeQty()");
		PiggyBankVer6 pBank = new PiggyBankVer6(3, 2, 3);
		System.out.println("Expected: Number of Dimes before adding = 2");
		System.out.println(String.format("  Actual: Number of Dimes before adding = %d", pBank.getDimes()));
		pBank.addDimes(-2);
		System.out.println("Expected: Number of Dimes after adding = 2");
		System.out.println(String.format("  Actual: Number of Dimes after adding = %d", pBank.getDimes()));
	}
	
	private static void testAddNickles_PositiveQty() {
		System.out.println("\n-->testAddNickles_PositiveQty()");
		PiggyBankVer6 pBank = new PiggyBankVer6(3, 2, 3);
		System.out.println("Expected: Number of Nickles before adding = 3");
		System.out.println(String.format("  Actual: Number of Nickles before adding = %d", pBank.getNickles()));
		pBank.addNickles(2);
		System.out.println("Expected: Number of Nickles after adding = 5");
		System.out.println(String.format("  Actual: Number of Nickles after adding = %d", pBank.getNickles()));
	}
	
	private static void testAddNickles_NegativeQty() {
		System.out.println("\n-->testAddNickles_NegativeQty()");
		PiggyBankVer6 pBank = new PiggyBankVer6(3, 2, 3);
		System.out.println("Expected: Number of Nickles before adding = 3");
		System.out.println(String.format("  Actual: Number of Nickles before adding = %d", pBank.getNickles()));
		pBank.addNickles(-2);
		System.out.println("Expected: Number of Nickles after adding = 3");
		System.out.println(String.format("  Actual: Number of Nickles after adding = %d", pBank.getNickles()));
	}
	
	private static void testGetTotal() {
		System.out.println("\n-->testGetTotal()");
		PiggyBankVer6 pBank = new PiggyBankVer6(3, 2, 3);
		pBank.addQuarters(3);
		pBank.addDimes(5);
		pBank.addNickles(6);
		pBank.withdrawQuarters(2);
		System.out.println("Expected: Total amount in the Piggy Bank = $2.15");
		System.out.println(String.format("  Actual: Total amount in the Piggy Bank = $%.2f", pBank.getTotal()));
		
	}
	
	private static void testToString() {
		System.out.println("\n-->testToString()");
		PiggyBankVer6 pBank = new PiggyBankVer6(3, 2, 3);
		pBank.addQuarters(3);
		pBank.addDimes(5);
		pBank.addNickles(6);
		pBank.withdrawQuarters(2);
		System.out.println("Expected: Quarters = 4, Dimes = 7, Nickles = 9, Total = $2.15");
		System.out.println(String.format("  Actual: %s", pBank.toString()));
	}
}
