package exercise_piggy_bank;

public class PiggyBankVer8Test {

	public static void main(String[] args) {
		testAddQuarters_PositiveQty();
		testAddQuarters_NegativeQty();
		testWithdrawQuarters_PositiveQty();
		testWithdrawQuarters_NegativeQty();
		testAddDimes_PositiveQty();
		testAddDimes_NegativeQty();
		testAddNickles_PositiveQty();
		testAddNickles_NegativeQty();
		testIsEmpty_Positive_InitializedWithMoney();
		testIsEmpty_Positive_InitalizedWithZero();
		testIsEmpty_Negative_InitializedWithZero();
		testIsEmpty_Negative_InitalizedWithMoney();
		testGetTotal();
		testToString();	
	}

	private static void testAddQuarters_PositiveQty() {
		System.out.println("-->testAddQuarters_PositiveQty()");
		PiggyBankVer8 pBank = new PiggyBankVer8(3, 2, 3);
		System.out.println("Expected: Number of Quarters before adding = 3");
		System.out.println(String.format("  Actual: Number of Quarters before adding = %d", pBank.getQuarters()));
		pBank.addQuarters(2);
		System.out.println("Expected: Number of Quarters after adding = 5");
		System.out.println(String.format("  Actual: Number of Quarters after adding = %d", pBank.getQuarters()));
	}
	
	private static void testAddQuarters_NegativeQty() {
		System.out.println("\n-->testAddQuarters_NegativeQty()");
		PiggyBankVer8 pBank = new PiggyBankVer8(3, 2, 3);
		System.out.println("Expected: Number of Quarters before adding = 3");
		System.out.println(String.format("  Actual: Number of Quarters before adding = %d", pBank.getQuarters()));
		pBank.addQuarters(-5);
		System.out.println("Expected: Number of Quarters after adding = 3");
		System.out.println(String.format("  Actual: Number of Quarters after adding = %d", pBank.getQuarters()));
	}
	
	private static void testWithdrawQuarters_PositiveQty() {
		System.out.println("\n-->testWithdrawQuarters_PositiveQty()");
		PiggyBankVer8 pBank = new PiggyBankVer8(3, 2, 3);
		System.out.println("Expected: Number of Quarters before withdrawing = 3");
		System.out.println(String.format("  Actual: Number of Quarters before withdrawing = %d", pBank.getQuarters()));
		pBank.withdrawQuarters(2);
		System.out.println("Expected: Number of Quarters after withdrawing = 1");
		System.out.println(String.format("  Actual: Number of Quarters after withdrawing = %d", pBank.getQuarters()));
	}
	
	private static void testWithdrawQuarters_NegativeQty() {
		System.out.println("\n-->testWithdrawQuarters_NegativeQty()");
		PiggyBankVer8 pBank = new PiggyBankVer8(3, 2, 3);
		System.out.println("Expected: Number of Quarters before withdrawing = 3");
		System.out.println(String.format("  Actual: Number of Quarters before withdrawing = %d", pBank.getQuarters()));
		pBank.withdrawQuarters(-2);
		System.out.println("Expected: Number of Quarters after withdrawing = 3");
		System.out.println(String.format("  Actual: Number of Quarters after withdrawing = %d", pBank.getQuarters()));
	}
	
	private static void testAddDimes_PositiveQty() {
		System.out.println("\n-->testAddDimes_PositiveQty()");
		PiggyBankVer8 pBank = new PiggyBankVer8(3, 2, 3);
		System.out.println("Expected: Number of Dimes before adding = 2");
		System.out.println(String.format("  Actual: Number of Dimes before adding = %d", pBank.getDimes()));
		pBank.addDimes(2);
		System.out.println("Expected: Number of Dimes after adding = 4");
		System.out.println(String.format("  Actual: Number of Dimes after adding = %d", pBank.getDimes()));
		
	}
	
	private static void testAddDimes_NegativeQty() {
		System.out.println("\n-->testAddDimes_NegativeQty()");
		PiggyBankVer8 pBank = new PiggyBankVer8(3, 2, 3);
		System.out.println("Expected: Number of Dimes before adding = 2");
		System.out.println(String.format("  Actual: Number of Dimes before adding = %d", pBank.getDimes()));
		pBank.addDimes(-2);
		System.out.println("Expected: Number of Dimes after adding = 2");
		System.out.println(String.format("  Actual: Number of Dimes after adding = %d", pBank.getDimes()));
	}
	
	private static void testAddNickles_PositiveQty() {
		System.out.println("\n-->testAddNickles_PositiveQty()");
		PiggyBankVer8 pBank = new PiggyBankVer8(3, 2, 3);
		System.out.println("Expected: Number of Nickles before adding = 3");
		System.out.println(String.format("  Actual: Number of Nickles before adding = %d", pBank.getNickles()));
		pBank.addNickles(2);
		System.out.println("Expected: Number of Nickles after adding = 5");
		System.out.println(String.format("  Actual: Number of Nickles after adding = %d", pBank.getNickles()));
	}
	
	private static void testAddNickles_NegativeQty() {
		System.out.println("\n-->testAddNickles_NegativeQty()");
		PiggyBankVer8 pBank = new PiggyBankVer8(3, 2, 3);
		System.out.println("Expected: Number of Nickles before adding = 3");
		System.out.println(String.format("  Actual: Number of Nickles before adding = %d", pBank.getNickles()));
		pBank.addNickles(-2);
		System.out.println("Expected: Number of Nickles after adding = 3");
		System.out.println(String.format("  Actual: Number of Nickles after adding = %d", pBank.getNickles()));
	}
	
	private static void testIsEmpty_Positive_InitializedWithMoney() {
		System.out.println("\n-->testIsEmpty_Positive_InitializedWithMoney()");
		PiggyBankVer8 pBank = new PiggyBankVer8(3, 2, 3);
		System.out.println("Expected: isEmpty = false");
		System.out.println("  Actual: isEmpty = " + pBank.isEmpty());
	}
	
	private static void testIsEmpty_Positive_InitalizedWithZero() {
		System.out.println("\n-->testIsEmpty_Positive_InitalizedWithZero()");
		PiggyBankVer8 pBank = new PiggyBankVer8(0, 0, 0);
		System.out.println("Expected: isEmpty before adding = true");
		System.out.println("  Actual: isEmpty before adding = " + pBank.isEmpty());
		pBank.addDimes(5);
		System.out.println("Expected: isEmpty after adding = false");
		System.out.println("  Actual: isEmpty after adding = " + pBank.isEmpty());
	}
	
	private static void testIsEmpty_Negative_InitializedWithZero() {
		System.out.println("\n-->testIsEmpty_Negative_InitializedWithZero()");
		PiggyBankVer8 pBank = new PiggyBankVer8(0, 0, 0);
		System.out.println("Expected: isEmpty = true");
		System.out.println("  Actual: isEmpty = " + pBank.isEmpty());
	}
	
	private static void testIsEmpty_Negative_InitalizedWithMoney() {
		System.out.println("\n-->testIsEmpty_Negative_InitalizedWithMoney()");
		PiggyBankVer8 pBank = new PiggyBankVer8(3, 0, 0);
		System.out.println("Expected: isEmpty before adding = false");
		System.out.println("  Actual: isEmpty before adding = " + pBank.isEmpty());
		pBank.withdrawQuarters(3);
		System.out.println("Expected: isEmpty after adding = true");
		System.out.println("  Actual: isEmpty after adding = " + pBank.isEmpty());
	}
	
	private static void testGetTotal() {
		System.out.println("\n-->testGetTotal()");
		PiggyBankVer8 pBank = new PiggyBankVer8(3, 2, 3);
		pBank.addQuarters(3);
		pBank.addDimes(5);
		pBank.addNickles(6);
		pBank.withdrawQuarters(2);
		System.out.println("Expected: Total amount in the Piggy Bank = $2.15");
		System.out.println(String.format("  Actual: Total amount in the Piggy Bank = $%.2f", pBank.getTotal()));
		
	}
	
	private static void testToString() {
		System.out.println("\n-->testToString()");
		PiggyBankVer8 pBank = new PiggyBankVer8(3, 2, 3);
		pBank.addQuarters(2000);
		pBank.addDimes(5000);
		pBank.addNickles(6000);
		pBank.withdrawQuarters(2);
		System.out.println("Expected: Quarters = 2001, Dimes = 5002, Nickles = 6003, Total = $1,300.60");
		System.out.println(String.format("  Actual: %s", pBank.toString()));
	}
}
