package exercise_piggy_bank;

public class PiggyBankVer9 {
	private int quarters;
	private int dimes;
	private int nickles;
	private boolean isEmpty;
	
	public PiggyBankVer9(int quarters, int dimes, int nickles) {
		this.quarters = quarters;
		this.dimes = dimes;
		this.nickles = nickles;
		evalIsEmpty();
	}

	public int getQuarters() {
		return quarters;
	}

	public void addQuarters(int numQuarters) {
		if(numQuarters > 0) {
			quarters += numQuarters;
			this.isEmpty = false;
		}
	}
	
	public int withdrawQuarters(int numQuarters) {
		if((numQuarters > 0) && (quarters >= numQuarters)) {
			quarters -= numQuarters;
			evalIsEmpty();
		}
		return numQuarters > 0 ? numQuarters : 0;
	}
	
	public int getDimes() {
		return dimes;
	}

	public void addDimes(int numDimes) {
		if(numDimes > 0) {
			dimes += numDimes;
			this.isEmpty = false;
		}
	}
	
	public int withdrawDimes(int numDimes) {
		if((numDimes > 0) && (dimes >= numDimes)) {
			dimes -= numDimes;
			evalIsEmpty();
		}
		return numDimes > 0 ? numDimes : 0;
	}

	public int getNickles() {
		return nickles;
	}

	public void addNickles(int numNickles) {
		if(numNickles > 0) {
			nickles += numNickles;
			this.isEmpty = false;
		}
	}
	
	public int withdrawNickles(int numNickles) {
		if((numNickles > 0) && (nickles >= numNickles)) {
			nickles -= numNickles;
			evalIsEmpty();
		}
		return numNickles > 0 ? numNickles : 0;
	}
	
	public boolean isEmpty() {
		return isEmpty;
	}
	
	public void mergeBank(PiggyBankVer9 pBank) {
		quarters += pBank.withdrawQuarters(pBank.getQuarters());
		dimes += pBank.withdrawDimes(pBank.getDimes());
		nickles += pBank.withdrawNickles(pBank.getNickles());
	}
	

	public double getTotal() {
		double total = ((quarters * 0.25) + (dimes * 0.10) + (nickles * 0.05));
		return total;
	}

	@Override
	public String toString() {
		String msg = String.format("Quarters = %d, Dimes = %d, Nickles = %d, Total = $%,.2f",
									quarters, dimes, nickles, getTotal());
		return msg;
	}
	
	
	/**
	 * Helper
	 */
	private void evalIsEmpty() {
		this.isEmpty = (quarters + dimes + nickles == 0) ? true : false;
	}
}
