package exercise_savings_account;

// adds mergeAccount
public class SavingsAccount3 {
	
	private double balance;
	private String owner;
	private double serviceFeeTotal = 0.0;
	private boolean isOverdrawn = false;

	public SavingsAccount3() {
		this(0.0, "Anonymous");
	}

	public SavingsAccount3(double balance) {
		this(balance, "Anonymous");
	}

	public SavingsAccount3(String owner) {
		this(0.0, owner);
	}

	public SavingsAccount3(double balance, String owner) {
		this.balance = balance;
		this.owner = owner;
	}

	public double getBalance() {
		return balance;
	}
	
	public String getOwner() {
		return owner;
	}

	public double getServiceFeeTotal() {
		return serviceFeeTotal;
	}

	public boolean isOverdrawn() {
		return isOverdrawn;
	}

	public void deposit(double amount) {
		if(amount > 0.0) {
			balance += amount;
		}
	}

	public void withdraw(double amount) {
		if(amount > 0.0) {
			balance -= amount;
			if(balance < 0.0) {
				balance -= 20.0;
				serviceFeeTotal += 20.0;
				isOverdrawn = true;
			}
			else {
				isOverdrawn = false;
			}
		}
	}

	public void applyInterest(double rate) {
		if(balance > 0.0) {
			balance *= (1.0 + rate);
		}
	}

	public void mergeAccount(SavingsAccount3 a) {
		if(this.owner.equals(a.owner)) {
			this.balance += a.balance;
			// This is one interpretation: no matter, if bal<0 after merge, penalize.
			// Another interpretation would be: if already overdrawn before merge, don't
			// penalize again.
			if(balance < 0.0) {
				balance -= 20.0;
				serviceFeeTotal += 20.0;
				isOverdrawn = true;
			}
			else {
				isOverdrawn = false;
			}
		}
	}

	@Override
	public String toString() {
		String msg = String.format("Account: balance=$%,.2f, serv fees=$%,.2f", balance, serviceFeeTotal);
		return msg;
	}

	public static void main(String[] args) {
	}
	
	
}

