package exercise_savings_account;

public class SavingsAccountTest {

	/*
	 * Does not contain test methods for applyInterest, getServiceFeeTotal, isOverdrawn
	 * 
	 * Added tests for applyInterest and getServiceFeeTotal. isOverdrawn does not need tests because 
	 * it is not part of the class.
	 */
	public static void main(String[] args) {
		testAccountCreation();
		testToString();
		testDeposit();
		testMultipleDeposits();		
		testDepositWithNegativeAmount();
		testWithdraw();
		testMultipleDepositsAndWithdrawals();		
		testWithdrawWithNegativeAmount();
		testApplyInterest_PositiveBalance();
		testApplyInterest_NegativeBalance();
		testServiceFee_PositiveBalance();
		testServiceFee_NegativeBalance();
	}
	
	private static void testAccountCreation() {
		System.out.println("-->testAccountCreation()");
		SavingsAccount a1 = new SavingsAccount(1000.0, "Xeno");
		System.out.println("balance should be $1000, balance=$" + a1.getBalance());
	}

	private static void testToString() {
		System.out.println("-->testToString()");
		SavingsAccount a1 = new SavingsAccount(1000.0, "Xeno");
		System.out.println("toString()=" + a1);
	}

	private static void testDeposit() {
		System.out.println("-->testDeposit()");
		SavingsAccount a1 = new SavingsAccount(1000.0, "Xeno");
		a1.deposit(500.0);
		System.out.println("balance should be $1500, balance=$" + a1.getBalance());
	}

	private static void testDepositWithNegativeAmount() {
		System.out.println("-->testDepositWithNegativeAmount()");
		SavingsAccount a1 = new SavingsAccount(1000.0, "Xeno");
		a1.deposit(-500.0);
		System.out.println("balance should be $1000, balance=$" + a1.getBalance());
	}

	private static void testMultipleDeposits() {
		System.out.println("-->testMultipleDeposits()");
		SavingsAccount a1 = new SavingsAccount(1000.0, "Xeno");
		a1.deposit(500.0);
		a1.deposit(300.0);
		System.out.println("balance should be $1800, balance=$" + a1.getBalance());
	}

	private static void testWithdraw() {
		System.out.println("-->testWithdraw()");
		SavingsAccount a1 = new SavingsAccount(1000.0, "Xeno");
		a1.withdraw(600.0);
		System.out.println("balance should be $400, balance=$" + a1.getBalance());
	}

	private static void testMultipleDepositsAndWithdrawals() {
		System.out.println("-->testMultipleDepositsAndWithdrawals()");
		SavingsAccount a1 = new SavingsAccount(1000.0, "Xeno");
		a1.deposit(500.0);
		a1.withdraw(200.0);
		a1.deposit(400.0);
		a1.withdraw(1000.0);
		System.out.println("balance should be $700, balance=$" + a1.getBalance());
	}

	private static void testWithdrawWithNegativeAmount() {
		System.out.println("-->testWithdrawWithNegativeAmount()");
		SavingsAccount a1 = new SavingsAccount(1000.0, "Xeno");
		a1.withdraw(-500.0);
		System.out.println("balance should be $1000, balance=$" + a1.getBalance());
	}

	private static void testApplyInterest_PositiveBalance() {
		System.out.println("-->testApplyInterest_PositiveBalance()");
		SavingsAccount a1 = new SavingsAccount(1000.0, "Mark");
		System.out.println("Expected: Balance before interest is applied = $1000.00");
		System.out.println(String.format("  Actual: Balance before interest is applied = $%.2f", a1.getBalance()));
		a1.withdraw(200.0);
		a1.deposit(700.0);
		a1.applyInterest(0.05);
		System.out.println("Expected: Balance after interest was applied = $1575.00");
		System.out.println(String.format("  Actual: Balance after interest was applied = $%.2f", a1.getBalance()));
		
	}
	
	private static void testApplyInterest_NegativeBalance() {
		System.out.println("-->testApplyInterest_NegativeBalance()");
		SavingsAccount a1 = new SavingsAccount(200.0, "Mark");
		a1.withdraw(250.0);
		System.out.println("Expected: Balance before interest is applied = $-70.00");
		System.out.println(String.format("  Actual: Balance before interest is applied = $%.2f", a1.getBalance()));
		a1.applyInterest(0.05);
		System.out.println("Expected: Balance after interest was applied = $-70.00");
		System.out.println(String.format("  Actual: Balance after interest was applied = $%.2f", a1.getBalance()));
	}
	
	private static void testServiceFee_PositiveBalance() {
		System.out.println("-->testServiceFee_PositiveBalance()");
		SavingsAccount a1 = new SavingsAccount(1000.0, "Mark");
		a1.withdraw(250.0);
		a1.withdraw(250.0);
		System.out.println("Expected: Service Fee for the month is = $0.00");
		System.out.println(String.format("  Actual: Service Fee for the month is = $%.2f", a1.getServiceFeeTotal()));
	}
	
	private static void testServiceFee_NegativeBalance() {
		System.out.println("-->testServiceFee_NegativeBalance()");
		SavingsAccount a1 = new SavingsAccount(500.0, "Mark");
		a1.withdraw(550.0);
		a1.deposit(100.0);
		a1.withdraw(200.0);
		System.out.println("Expected: Service Fee for the month is = $40.00");
		System.out.println(String.format("  Actual: Service Fee for the month is = $%.2f", a1.getServiceFeeTotal()));
	}	
}
