package exercise_savings_account_utilities;

public class SavingsAccountTest {

	public static void main(String[] args) {
		SavingsAccount[] acnts =
				{ new SavingsAccount("Tenesha", 2000.0),
				  new SavingsAccount("Niles", 5000.0),
				  new SavingsAccount("Xavier", 1000.0)
				};

		System.out.println(String.format("Total Balance of all accounts: $%,.2f", totalBalance(acnts)));
		applyInterest(acnts, 0.1);
		System.out.println(String.format("Total Balance of all accounts: $%,.2f", totalBalance(acnts)));
		System.out.println(accountsReport(acnts));
	}

	public static double totalBalance(SavingsAccount[] acnts) {
		double sum = 0.0;
		for(SavingsAccount sa : acnts) {
			sum += sa.getBalance();
		}
		return sum;
	}

	public static void applyInterest(SavingsAccount[] acnts, double intRate) {
		for(SavingsAccount sa : acnts) {
			sa.applyInterest(intRate);
		}
	}

	public static String accountsReport(SavingsAccount[] acnts) {
		String msg = "";
		for(SavingsAccount sa : acnts) {
			msg += String.format("Account owner=%s, balance=$%,.2f\n", sa.getOwner(), sa.getBalance() );
		}
		return msg;
	}

}
