package exercise_savings_account_utilities;

public class SavingsAccountUtilitiesTest {

	public static void main(String[] args) {
		testGetAccountsReport();
		testApplyInterest();
		testGetAccountOwnerList();
		testGetSmallestAccounts();
	}
	
	private static void testGetAccountsReport() {
		System.out.println("Test getAccoutsReport(accounts)");
		SavingsAccount[] acnts = createAccounts();
		SavingsAccountUtilities saUtil = new SavingsAccountUtilities();
		
		String report = saUtil.getAccountsReport(acnts);
		
		System.out.println(report);
	}
	
	private static void testApplyInterest() {
		System.out.println("\n-->testApplyInterest()");
		SavingsAccount[] acnts = createAccounts();
		SavingsAccountUtilities saUtil = new SavingsAccountUtilities();
		System.out.println("Report before interest (5%) is applied = ");
		System.out.println(saUtil.getAccountsReport(acnts));
		saUtil.applyInterest(acnts, 0.05);
		System.out.println("Report after interest (5%) is applied = ");
		System.out.println(saUtil.getAccountsReport(acnts));
	}
	
	private static void testGetAccountOwnerList() {
		System.out.println("\n-->testGetAccountOwnerList()");
		SavingsAccount[] acnts = createAccounts();
		SavingsAccountUtilities saUtil = new SavingsAccountUtilities();
		System.out.println("Expected: Owners [Tenesha, Niles, Xavier]");
		String actual = "  Actual: Owners [";
		String[] owners = saUtil.getAccountOwnersList(acnts);
		for(String owner : owners) {
			actual += owner + ", ";
		}
		System.out.println(actual.substring(0, actual.length() -2) + "]");
	}
	
	private static void testGetSmallestAccounts() {
		System.out.println("\n-->testGetSmallestAccounts()");
		SavingsAccount[] acnts1 = createAccounts();
		SavingsAccount[] acnts2 = create2ndAccounts();
		SavingsAccountUtilities saUtil = new SavingsAccountUtilities();
		SavingsAccount[] smallest = saUtil.getSmallestAccounts(acnts1, acnts2);
		System.out.println("Expected: ");
		System.out.println("Smallest Accounts Report: ");
		System.out.println("Accounts Summary\n"
				+ "----------------\n"
				+ "Num accounts = 3\n"
				+ "Total balance = $7,000.00\n\n"
				+ "Accounts:\n"
				+ "Owner=Rashel, bal=$1,500.00\n"
				+ "Owner=Niles, bal=$5,000.00\n"
				+ "Owner=Jackson, bal=$500.00\n");
		System.out.println("  Actual: ");
		System.out.println("Smallest Accoutns Report: ");
		System.out.println(saUtil.getAccountsReport(smallest));
	}
	
	
	
	
	/**
	 * Helper
	 */
	private static SavingsAccount[] createAccounts() {
		SavingsAccount[] acnts = { 
			  new SavingsAccount("Tenesha", 2000.0),
			  new SavingsAccount("Niles", 5000.0),
			  new SavingsAccount("Xavier", 1000.0)
			};
		return acnts;
	}
	
	private static SavingsAccount[] create2ndAccounts() {
		SavingsAccount[] acnts = { 
				  new SavingsAccount("Rashel", 1500.0),
				  new SavingsAccount("John", 7500.0),
				  new SavingsAccount("Jackson", 500.0)
				};
			return acnts;
	}
}
